unit Arkanoid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, Menus;

const
      maxX = 16;          //maximalni pocet cihel v horizontalnim smeru
      maxY = 17;          //maximalni pocet cihel ve vertikalnim smeru
      vclient_W = 1100;    //sirka okna
      vclient_H = 660;    //vyska okna
      dwidth = 800;       //sirka hraciho pole
      dheight = 600;      //vyska hraciho pole
      odsazenix = 0;     //odsazeni hraciho pole od formulare
      odsazeniy = 0;
      vyska = 50;         //vyska plosiny nad spodkem hraciho pole
      Zakl_rychl = 4;    //rychlost micku na zacatku kola, nebo noveho zivota
      zmena = 1;          //o kolik se zmeni rychlost po odrazu od plosiny
      fps = 5;           //interval casovace
      cihla_W = 50;      //sirka a vyska cihly
      cihla_H = 25;
      cihel   = 5;       // kolik druhu cihel

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    Hra1: TMenuItem;
    Novhra1: TMenuItem;
    Editor1: TMenuItem;
    Pause1: TMenuItem;
    Konec1: TMenuItem;
    Npovda1: TMenuItem;
    Oprogramu: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lblGameOver: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure OprogramuClick(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure Novhra1Click(Sender: TObject);
    procedure Editor1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type

  {Tplosina}

  TPlosina = class(Timage)
    private
      bitmapa: Tbitmap;
      pX,pY: integer;     //pocatecni pozice
    public
     constructor Create(AOwner: Tcomponent); override;
     procedure Nastav(sender: Tobject; Shift: TShiftState; X,
                      Y: Integer);    //nastavi plosinu na urcenou pozici
     procedure Umisti(x,y:integer);
   end;

  {Tplosina - konec deklarace}


  {TMicec}

  TKulicka = class(TImage)
  private
    pX: integer;   //pocatecni pozice
    pY: integer;
    incX: integer;
    incY: integer;  //o kolik se ma posunout kulicka
    obrazek: TBitmap;
    timer: Ttimer;      //timer pro pohyb micku
    rychlost: integer;

  public
    constructor Create(Aowner: Tcomponent);override;
    procedure Pohybuj(sender: TObject);
    function Kolize: byte;
  end;

  {TMicek - konec deklarace}

  {TCihla}

  Tcihla = class(Timage)
  private
    pX: integer;   //pozice cihly
    pY: integer;
  public
    bouchni: byte;
    typ: integer;      //0-neni cihla, 1-cervena,2-modra, 3-zelena, 4-ctyri bouchnuti, 5-neznicitelna
    constructor Create(AOwner: Tcomponent);override;
    procedure Umisti(x,y: integer);    //parametry, jsou umisteni leveho horniho rohu cihly
    procedure NastavMys(sender: Tobject; Shift: TShiftState; X, Y: Integer);
   // destructor Destroy;override;
  end;

  {TCihla - konec deklarace}

  {Thra}

  THra = class(Tobject)
  private
    pozadi: Tbitmap;  //obrazek na pozadi
    desktop: Timage;        //hraci plocha
  public
    level: integer;   //jaky level se momentalne hraje
    pocet: integer;   //pocet zbyvajicich cihel
    score: integer;
    plosina: Tplosina;
    kulicka: Tkulicka;
    zivoty: integer;
    cihly: array[1..maxX,1..MaxY] of Tcihla;
    hrej: boolean;
    Bstart: TButton;
    Smapa: string;
    Grafika: array [1..cihel] of Tbitmap;
    constructor Create(Aowner: Tcomponent);
    procedure VytvorMapu;
    procedure NactiMapu;
    procedure ZrusMapu;
    procedure NovaHra(sender:Tobject);
    procedure Dalsilevel;
    procedure DalsiZivot;
    procedure Pokracuj(Sender: TObject);
    procedure Pause;
    procedure KonecHry;
  end;

  {Thra - konec deklarace}


var
  frmMain: TfrmMain;
  hra: Thra;
  neco: integer;

implementation

uses Editor,About;

{$R *.dfm}

{THra - implementace}

constructor Thra.Create(Aowner:Tcomponent);
begin
  inherited Create;
  hrej := false;
  VytvorMapu;
  Plosina := TPlosina.Create(frmMain);
  kulicka := TKulicka.Create(frmMain);


  Bstart := TButton.Create(frmMain);
  with Bstart do
  begin
    parent := frmMain;
    left := odsazenix + dwidth + 25;
    top := 100;
    width := 50;
    height := 25;
    Caption := 'Start';
    TabOrder := 0;
    OnClick := pokracuj;
  end;


end;


procedure THra.VytvorMapu;


begin
  desktop:= Timage.Create(frmMain);
  pozadi := TBitmap.Create;
  pozadi.LoadFromFile(ExtractFilePath(Application.ExeName)+'images/pozadi.bmp');
  with desktop do
  begin
    parent:= frmMain as TwinControl;
    top   := odsazeniy;
    left  := odsazenix;
    width := dwidth;
    height:= dheight;
    Canvas.Create;
    Canvas.Brush.Color := clblack;
    canvas.Rectangle(0,0,Width,Height);
    visible:= true;
    OnMouseMove := plosina.Nastav;
  end;


end;


procedure THra.NactiMapu;
var
   i,j: integer;
   FMapa: file of integer;


begin
  pocet := 0;
  SMapa := ExtractFilePath(Application.ExeName) + 'maps\level_'+intToStr(level)+'.map';
  try
    assignFile(Fmapa,SMapa);
    Reset(Fmapa);
  except
    on Exception do ShowMessage('Soubor se nepodarilo otevrit');
  end;
  Try
    for i:=1 to maxX do
      for j:=1 to maxY do
        begin
          cihly[i,j]:= Tcihla.Create(frmMain);
          with cihly[i,j] do
          begin
            Read(Fmapa,typ);
            case typ of
              1,2,3: bouchni:= 1;
              4: bouchni := 4;
              5: bouchni := 0;
            end;
            pX := (i-1) * cihla_W;
            pY := (j-1) * cihla_H;
            if (typ <> 0) then
            begin
              inc(pocet);
              Umisti(pX,pY);
            end;
          end;


        end;

  finally
    closeFile(Fmapa);
  end;
end;


procedure Thra.ZrusMapu;
var i,j:integer;

begin
  for i:=1 to maxX do
    for j:= 1 to maxY do
      cihly[i,j].Destroy;

end;


Procedure Thra.NovaHra(sender:Tobject);
begin
  if (level > 1) then
  begin
    ZrusMapu;
  end;
  level := 1;
  frmMain.Label2.caption := inttoStr(level);
  score := 0;
  frmMain.Label4.caption := intToStr(score);
  NactiMapu;
  hrej := true;
  kulicka.Visible := True;
  plosina.Visible := True;
  kulicka.timer.enabled := true;

end;


procedure Thra.Dalsilevel;
begin
  inc(level);
  frmMain.Label2.caption := inttoStr(level);
  ZrusMapu;
  NactiMapu;
  plosina.Left := hra.plosina.pX;
  kulicka.Left := kulicka.pX;
  kulicka.Top := kulicka.pY;
  kulicka.timer.Enabled := false;
  hrej := false;

end;


procedure Thra.DalsiZivot;
begin
  dec(zivoty);
  if (zivoty = 0) then
    KonecHry
  else
  begin
    plosina.Left := hra.plosina.pX;
    kulicka.Left := kulicka.pX;
    kulicka.Top := kulicka.pY;
    kulicka.timer.Enabled := false;
    hrej := True;
  end;
end;

procedure THra.pokracuj(Sender: TObject);
begin
  if (level = 0) then
    novaHra(sender);
  hrej := True;
  hra.kulicka.timer.Enabled := True;

end;

procedure Thra.Pause;
begin

  hrej := false;
  hra.kulicka.timer.Enabled := false;

end;


procedure THra.KonecHry;
begin
  kulicka.timer.Enabled := false;
  hrej := false;
  frmMain.lblGameOver.Visible := True;

end;


{Tplosina - implementace}

constructor TPlosina.Create(Aowner: Tcomponent);
begin

   inherited Create(Aowner);
   bitmapa := TBitmap.Create;
   bitmapa.LoadFromFile(ExtractFilePath(Application.ExeName)+'images/plosina.bmp');
   parent  := aowner as TwinControl;



   width   := bitmapa.Width;
   height  := bitmapa.Height;
   pX      := (dwidth div 2) - (width div 2);
   pY      := odsazeniY + dheight - vyska;
   left    := pX;
   top     := pY;
   picture.Assign(bitmapa);
   visible:= false;
   //OnMouseMove := frmMain.OnMouseMove;

end;


Procedure TPlosina.Umisti(x,y: integer);
begin
  left := x;
  top := y;
end;


Procedure TPlosina.Nastav(sender: Tobject; Shift: TShiftState; X,
  Y: Integer);


begin

  if hra.hrej then
    if (X > odsazenix) and (X < hra.desktop.left + dwidth - hra.plosina.Width) then
    begin
      hra.plosina.left := X;
      hra.plosina.top  := hra.plosina.pY;
    end;


end;

{TKulicka - implementace}

constructor Tkulicka.Create(Aowner: TComponent);
begin
  inherited Create(AOwner);

  obrazek := Tbitmap.Create;
  obrazek.LoadFromFile(ExtractFilePath(Application.ExeName)+'images/micek.bmp');

  parent := AOwner as TwinControl;
  width := obrazek.width;
  height := obrazek.height;
  pX := (dwidth div 2) - (width div 2);
  pY := odsazeniY + dheight - vyska - height;
  left := pX;
  top := pY;
  picture.Assign(obrazek);
  visible := false;

  timer := TTimer.Create(frmMain);
  with timer do
  begin
    interval := fps;
    enabled := false;
    ontimer := Pohybuj;
  end;

  rychlost := Zakl_rychl;
  incX := rychlost;
  incY := -rychlost;

end;

procedure TKulicka.Pohybuj(Sender: TObject);
begin
  //if (left > 600) or (left < 100) or (top > 500) or (top < 50) then
  case kolize of
  1: incX := -incX;
  2: incY := -incY;
  3: incX := -incX;
  4: begin
       if (top < (dheight div 2)) then
         hra.dalsiZivot
       else
         incY := -incY;
     end;
  5:
  {plosina rozdelena na 5 casti, na kraji se micek odrazi pod vetsim uhlem, nebo zpatky
  v dalsich dvou se micek odrazi pod vetsim uhlem, v prostredni se odrazi pod stejnym uhlem}

  if ((left+width) < ((hra.plosina.Width div 5) + hra.plosina.left)) then //micek je v leve krajni casti
       begin
         if (left < (left + incX)) then     //micek priletel zleva
           incX := -(incX);
         if (Abs(incY) = (rychlost-zmena)) then    //micek uz priletel pod mensim uhlem
           incY := -(incY)                         //proto se odrazi pod stejnym uhlem
         else
           incY := -(rychlost-zmena);         //micek priletel pod jinym uhlem nez mensim
       end                                    //proto se odrazi pod mensim uhlem
     else
       if (left > (((hra.plosina.width div 5) * 4) + hra.plosina.left)) then
         begin
           if (left > (left + incX)) then          //to same jako predtim, jen na pravo
             incX := -incX;
           if (abs(incY) = (rychlost-zmena)) then
             incY := -(incY)
           else
             incY := -(rychlost-zmena);
         end
       //else
         //incY := -incY;

      else
        if (((left + width) < (((hra.plosina.Width div 5)*2) + hra.plosina.Left))) then
          //micek je ve vnitri leve casti, odrazi se pod vetsim uhlem
          if (left < (left + incX)) then
           begin
             incX:= -incX;
             if (Abs(incY) = (rychlost + zmena)) then  //micek uz pod vetsim uhlem priletel, odrazi se pod stejnym
               incY := -(incY)
             else
               incY := -(rychlost + zmena);   //micek se odrazi pod vetsim uhlem
           end
          else
             if (Abs(incY) = (rychlost + zmena)) then  //micek uz pod vetsim uhlem priletel, odrazi se pod stejnym
               incY := -(incY)
             else
               incY := -(rychlost + zmena)   //micek se odrazi pod vetsim uhlem
      else
        if (Left > (((hra.plosina.Width div 5) * 3) + hra.plosina.left)) then
        //micek v prave druhe casti
          if (left > (left + incX)) then
           begin
             incX:= -incX;
             if (Abs(incY) = (rychlost + zmena)) then  //micek uz pod vetsim uhlem priletel, odrazi se pod stejnym
               incY := -(incY)
             else
               incY := -(rychlost + zmena);   //micek se odrazi pod vetsim uhlem
           end
          else
             if (Abs(incY) = (rychlost + zmena)) then  //micek uz pod vetsim uhlem priletel, odrazi se pod stejnym
               incY := -(incY)
             else
               incY := -(rychlost + zmena)   //micek se odrazi pod vetsim uhlem
      else
        if ((Left + width) >(((hra.plosina.Width div 5) * 2) + hra.plosina.Left)) then
          begin
            incY:= -incY;
          end;

  end;
  left := left + incX;
  top := top + incY;

end;


function Tkulicka.Kolize: byte;
{
vraci, se kterou stenou nastala kolize (plati i pro cihly)
u cihly je dolni stena vlastne vrsek cihly
0 - nenastala kolize
1 - kolize s pravou stenou      i pro cihly
2 - kolize s horni stenou
3 - kolize s levou stenou
4 - kolize s dolni stenou
5 - kolize s plosinou
}

var
  poziceX: integer;   //pozice micku pote co by znovu pohnul
  poziceY: integer;
  kolikX, kolikY: integer;   //v jaky budu pripadne cihle

begin
  poziceX := left + incX;
  poziceY := top + incY;
  kolize := 0;            //neni kolize, kdyby byla, tak se zmeni v ifech

  if (poziceX + width) > (odsazeniX + dwidth) then
    kolize := 1;
  if (poziceX) < (odsazeniX) then
    kolize := 3;
  if (poziceY + height) > (odsazeniY + dheight) then
    kolize := 4;
  if poziceY < odsazeniY then
    kolize := 2;

  if (((poziceY + height) > (odsazeniY + dheight - vyska))
  and ((poziceY + Height) < (odsazeniY + dheight - vyska + hra.plosina.Height ))
  and (hra.plosina.Left < (left + width))
  and ((hra.plosina.Left + hra.plosina.width) > left))
  then
    kolize := 5;

  //test kolize s cihlou
  kolikX := (poziceX div cihla_W) + 1;
  kolikY := (poziceY div cihla_H) + 1;
  if (((Left < poziceX) and (top > poziceY)) or ((left < poziceX) and (top < poziceY))) then
    kolikX := ((poziceX + width) div cihla_W) + 1;

  if (((left < poziceX) and (top < poziceY)) or ((left > poziceX) and (top < poziceY))) then
    kolikY := ((poziceY + height) div cihla_H) + 1;


    if (kolikY <= maxY) then
    begin
      if (kolikX <= maxX) then
      if (hra.cihly[kolikX,kolikY].typ <> 0) then
      begin
      if ((hra.cihly[kolikX,kolikY].typ = 5) or (hra.cihly[kolikX,kolikY].bouchni <> 0 )) then
      begin
        if ((Left < poziceX) and (top > poziceY)) then
          if ((left + width) <= hra.cihly[kolikX,kolikY].Left) then
            kolize := 1
          else
            kolize:= 2
        else
          if((Left > poziceX) and (top > poziceY)) then
            if (left >= (hra.cihly[kolikX,kolikY].Left + hra.cihly[kolikX,kolikY].width)) then
              kolize := 3
            else
              kolize := 2
        else
          if ((left < poziceX) and (top < poziceY)) then
            if ((left + width) <= hra.cihly[kolikX,kolikY].Left) then
              kolize := 1
            else
              kolize := 4
          else
            if ((left > poziceX) and (top < poziceY)) then
              if (left >= (hra.cihly[kolikX,kolikY].Left + hra.cihly[kolikX,kolikY].width)) then
                kolize := 3
              else
                kolize := 4;

        hra.cihly[kolikX,kolikY].bouchni := hra.cihly[kolikX,kolikY].bouchni - 1;
        if (hra.cihly[kolikX,kolikY].bouchni <= 0) then
        begin
          hra.cihly[kolikX,kolikY].Visible := false;
          dec(hra.pocet);
          //score := score + 20;
          //frmMain.Label4.caption := intToStr(score);
          if (hra.pocet = 0) then
            hra.dalsilevel;
        end;
      end;
      end;
    end;



end;

{TCihla - implementace}
constructor TCihla.Create(AOwner: TComponent);
begin
  inherited Create(frmMain);

  parent := AOwner as TwinControl;
  width := cihla_w;
  height := cihla_h;


end;


procedure TCihla.Umisti(x,y: integer);
var
  obrazek: TBitmap;

begin
  obrazek := Tbitmap.Create;
  obrazek.LoadFromFile(ExtractFilePath(application.ExeName)+'images\Block_'+intToStr(typ)+'.bmp');
  left:= x;
  top := y;
  picture.Assign(obrazek);

  OnMouseMove := nastavmys; //frmMain.OnMouseMove;
  visible := True;
end;

procedure Tcihla.NastavMys(sender: Tobject; Shift: TShiftState; X,  Y: Integer);
var
  myX: integer;

begin
  myX:= x + pX;
  hra.plosina.Nastav(sender,shift,myX,Y);

end;

{Tform - implementace}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
   top := 50;
   left := 30;
   width := vclient_W;
   height := vclient_H;
   //windowState := wsMaximized;
   hra:= Thra.Create(frmMain);

end;


procedure TfrmMain.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  // if hra.hrej then
   //  hra.plosina.Nastav(x,hra.plosina.pY);
end;

procedure TfrmMain.OprogramuClick(Sender: TObject);
begin
  frmAbout.showmodal;
end;

procedure TfrmMain.Pause1Click(Sender: TObject);
begin
  if hra.hrej then
  begin
    hra.hrej := false;
    hra.kulicka.timer.Enabled := false;
  end
  else
  begin
    hra.hrej := True;
    hra.kulicka.timer.Enabled := True;
  end;
end;

procedure TfrmMain.Novhra1Click(Sender: TObject);
begin
  hra.NovaHra(sender);
end;

procedure TfrmMain.Editor1Click(Sender: TObject);
begin
  frmEditor.showmodal;
end;

end.



