unit Editor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, arkanoid, Grids, ExtCtrls, StdCtrls;

type
  Tfrmeditor = class(TForm)
    Im1: TImage;
    Label2: TLabel;
    Im2: TImage;
    Label3: TLabel;
    ImVybr: TImage;
    Im3: TImage;
    Label1: TLabel;
    Im4: TImage;
    Label4: TLabel;
    Im5: TImage;
    btnUloz: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Im1Click(Sender: TObject);
    procedure Im2Click(Sender: TObject);
    procedure Im4Click(Sender: TObject);
    procedure Im3Click(Sender: TObject);
    procedure Im5Click(Sender: TObject);
    procedure btnUlozClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;


type
  TBlock = class (TImage)
  private
    pX,pY: integer;        //umisteni cihly na plose
  public
    typ: byte;        //typy cihel
                      {
                      0 - zadna cihla
                      1 - modra
                      2 - zelena
                      3 - cervena
                      4 - zelena(vic bouchnuti)
                      5 - neznicitelna
                      }
    procedure Rozsvit(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Zhasni(x,y: integer);
  end;

var
  frmeditor: Tfrmeditor;
  cihly: array [1..maxX,1..maxY] of TBlock;
  grafika: array [1..cihel] of TBitmap;
  vybrano: byte;



implementation

{$R *.dfm}


Procedure TBlock.Zhasni(x,y: integer);
begin
  with cihly[x,y] do
  begin
    typ:= 0;
    canvas.Brush.Color := clWhite;
    canvas.Rectangle(0,0,width,height);
  end

end;


procedure TBlock.Rozsvit(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) then
    if vybrano <> 0 then
    begin
      typ:= vybrano;
      cihly[pX,pY].Picture := frmEditor.imVybr.picture;//Assign(grafika[vybrano]);
      cihly[pX,pY].Visible := True;
    end;
  if (Button = mbRight) then
    Zhasni(pX,pY);
end;


procedure Tfrmeditor.FormCreate(Sender: TObject);
var
  i,j: integer;

begin
  top := 0;
  left := 0;
  height := vclient_H-50;
  width  := dwidth+10;
  vybrano := 0;       //nevybrana zadna cihla do editovani
  //nacteni grafiky cihel
  for i:= 1 to cihel do
  begin
    grafika[i] := Tbitmap.Create;
    grafika[i].LoadFromFile(ExtractFilePath(application.exeName) + 'images/Block_'+IntToStr(i)+'.bmp');
  end;

  for i:=1 to maxX do
    for j:=1 to maxY do
      begin
      cihly[i,j] := TBlock.Create(frmEditor);
      with cihly[i,j] do
        begin
          parent:= frmEditor;
          left := (i-1)*cihla_W;
          top  := (j-1)*cihla_H;
          width:= cihla_W;
          height:= cihla_H;
          pX := i;
          pY := j;
          typ := 0;
          Canvas.Brush.Color := clWhite;
          canvas.Rectangle(0,0,width,height);
          OnMouseDown := Rozsvit;

        end;

      end;


end;



procedure Tfrmeditor.Im1Click(Sender: TObject);
begin
  ImVybr.Picture := Im1.Picture;
  vybrano:= 1;
end;

procedure Tfrmeditor.Im2Click(Sender: TObject);
begin
  ImVybr.Picture := Im2.Picture;
  vybrano:= 2;
end;


procedure Tfrmeditor.Im3Click(Sender: TObject);
begin
  ImVybr.Picture := Im3.Picture;
  vybrano:= 3;
end;

procedure Tfrmeditor.Im4Click(Sender: TObject);
begin
  ImVybr.Picture := Im4.Picture;
  vybrano:= 4;
end;

procedure Tfrmeditor.Im5Click(Sender: TObject);
begin
  ImVybr.Picture := Im5.Picture;
  vybrano:= 5;
end;

procedure Tfrmeditor.btnUlozClick(Sender: TObject);
var
  i,j,k: integer;
  Soubor: file of integer;//TextFile;
  cesta: String;
  co: integer;

begin
  k:= 1;
  cesta := ExtractFilePath(application.exeName) + 'maps\level_'+ intToStr(k) + '.map';
  while FileExists(cesta) do
    begin
      inc(k);
      cesta := ExtractFilePath(application.exeName) + 'maps\level_'+ intToStr(k) + '.map';
    end;
  AssignFile(soubor,cesta);
  Rewrite(soubor);
  for i:=1 to maxX do
    for j:= 1 to maxY do
      begin
        co := cihly[i,j].typ;
        Write(soubor,co);
      end;
  ShowMessage('Level uspesne ulozen pod nazvem level_'+intToStr(k)+'.map');
  CloseFile(soubor);
end;

end.
